 package praktikum12;

 import java.awt.*;         // Graphics
 import javax.swing.*;      // JPanel
 import java.awt.event.*;

 /************************************************************
 * Joonistamise alaks olev tahvel (akna raamis). 
 * @author Jri Kiho 
 * @version 01.05.2009
 */
 public class Tahvel extends JPanel implements MouseListener{ 

 	/**
 	* Vaiketaust.
 	*/
  	public static final Color TAUST = Color.white ; 

 	/**
 	* Kas XORMode demo (muidu: PaintMode demo)
 	*/
	public boolean xorLaad;

 	/**
 	* Limed, mis on tahvlile joonistamas.
 	*/
	private MulliJuhtija lim1;
	private MulliJuhtija lim2;

	 /************************************************************
 	 * Konstruktor. 
	 * Seatakse taustvrv ja lisatakse hiirekuular.
 	 */
	public Tahvel (boolean xor){
		xorLaad = xor;
        	setBackground(TAUST) ;
		addMouseListener(this);

 	}

	 /************************************************************
 	 * Tegelik joonistamine. 
	 * Kivitub tahvli tekkimisel/muutmisel ja erijuhul hiireklpsu korral sellel tahvlil.
	 * @param g joonistamise graafikakontekst (ssteemist) 
 	 */
 	public void paintComponent ( Graphics g ){
        	super.paintComponent(g);
		if((lim1 == null || !lim1.isAlive())&&(lim2 == null || !lim2.isAlive())){
		// kui mullisid (enam/veel) ei joonistata, siis uued mullid kima:
			Mull m1 = new Mull(-Mull.LAIUS, 100, Color.red);
			Mull m2 = new Mull(laius(), 100, Color.blue);
			lim1 = new MulliJuhtija(m1, this, 1, m2);
			lim2 = new MulliJuhtija(m2, this, -1, m1);

			// joonistab kogu aeg mulli m1 
			lim1.start(); 

			// joonistab kogu aeg mulli m2 
			lim2.start(); 
		}
		else{ // kustutada sealt, kuhu olid jnud:
			if(xorLaad){
				lim1.mull().joonistada(g);
				lim2.mull().joonistada(g);
			}
		
		}
		// tahvli veerandijooned:
		g.setColor(Color.green);
		g.fillRect(laius()/2 - 2, 0, 4, krgus());
		g.fillRect(laius()/4 - 2, 0, 4, krgus());
		g.fillRect(laius()/4*3 - 2, 0, 4, krgus());
 	}

	 /************************************************************
 	 * Tahvli laius. 
	 * @return Selle tahvli laius pikselites. 
 	 */
 	public int laius(){
        	return getSize().width;
 	}

	 /************************************************************
 	 * Tahvli krgus. 
	 * @return Selle tahvli krgus pikselites. 
 	 */
 	public int krgus(){
        	return getSize().height;
 	}
	// nutud MouseListeneri poolt:
	 	public void mouseExited(MouseEvent e){}
 		public void mouseEntered(MouseEvent e){}
	 	public void mousePressed(MouseEvent e){}
 		public void mouseReleased(MouseEvent e){}
	 	public void mouseClicked(MouseEvent e){repaint();}

}